package com.engine.salary.mapper.archive;

import com.engine.salary.entity.salaryarchive.dto.SalaryItemAdjustRecordListDTO;
import com.engine.salary.entity.salaryarchive.param.SalaryArchiveItemQueryParam;
import com.engine.salary.entity.salaryarchive.param.SalaryItemAdjustRecordQueryParam;
import com.engine.salary.entity.salaryarchive.po.SalaryArchiveItemPO;
import com.engine.salary.entity.siarchives.po.InsuranceArchivesOtherSchemePO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface SalaryArchiveItemMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<SalaryArchiveItemPO> listAll();
    
    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<SalaryArchiveItemPO> listSome(SalaryArchiveItemPO salaryArchiveItem);
    

	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	SalaryArchiveItemPO getById(Long id);
	
	/**
     * 新增，忽略null字段
     *
     * @param salaryArchiveItem 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(SalaryArchiveItemPO salaryArchiveItem);
	
	/**
     * 修改，修改所有字段
     *
     * @param salaryArchiveItem 修改的记录
     * @return 返回影响行数
     */
	int update(SalaryArchiveItemPO salaryArchiveItem);
	
	/**
     * 修改，忽略null字段
     *
     * @param salaryArchiveItem 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(SalaryArchiveItemPO salaryArchiveItem);
	
	/**
     * 删除记录
     *
     * @param salaryArchiveItem 待删除的记录
     * @return 返回影响行数
     */
	int delete(SalaryArchiveItemPO salaryArchiveItem);



	/**
	 * 批量插入
	 * @param salaryArchiveItemSaves
	 */
	void batchInsert(@Param("collection") List<SalaryArchiveItemPO> salaryArchiveItemSaves);

	/**
	 * 查询薪资项目调整记录列表
	 * @param param
	 * @param salaryItemIds
	 * @return
	 */
	List<SalaryItemAdjustRecordListDTO> salaryItemAdjustRecordList(@Param("param") SalaryItemAdjustRecordQueryParam param, @Param("salaryItemIds") List<Long> salaryItemIds);


	List<SalaryArchiveItemPO> listByParam(@Param("param")SalaryArchiveItemQueryParam build);

    List<SalaryArchiveItemPO> getIneffectiveSalaryItems(@Param("param") SalaryArchiveItemQueryParam build);

	List<SalaryArchiveItemPO> getEffectiveSalaryItems(@Param("param") SalaryArchiveItemQueryParam build);

	void deleteBatchIds(@Param("effectiveSalaryItemDels") List<Long> effectiveSalaryItemDels);


	void deleteBySalaryArchiveId(@Param("salaryArchiveIds") List<Long> salaryArchiveIds);

	void batchDeleteHistoryData(SalaryArchiveItemPO build);

	int batchUpdate(@Param("collection") List<SalaryArchiveItemPO> pos);
}